function a=subsasgn(a,s,b)
% F.C. : to improve
% 
  assert( isamat(a) ,'a must be a amat object');
  if isempty(b), return;end
  switch s(1).type
      case '.'
         if length(s) == 1
            % Implement obj.PropertyName = varargin{:};
            %...
            prop = s(1).subs;
            a.(prop)=b;
            
         end
      case '()'
        assert(length(s)==1)
        subs=s.subs;
        if length(subs)==1 % Implement a(k): return the k-th matrice, 
          if isscalar(subs{1})
            a.values(subs{1},:,:)=b;
            a.N=size(a.values,1);
            return
          end
          
          if  ~isamat(b) && ndims(b)==2 && a.nc~=1
            if isscalar(b)
              a.values(subs{1},:,:)=b;
            else
              assert( size(b,1)==a.nr && size(b,2)==a.nc )
              a.values(subs{1},:,:)=permute(repmat(b,[1,1,length(subs{1})]),[3,1,2]);
            end
            a.N=size(a.values,1);
            return
          end
          if ~isamat(b),b=amat(b);end
          if length(subs{1}) == b.N
              a.values(subs{1},:,:)=b.values;
              a.N=size(a.values,1);
              return
          end
          error('Trouble ...')
        end
        if length(subs)==2 % Implement a(i,j): as a.values(:,i,j)
          if isamat(subs{1}) && isamat(subs{2})  % return a(:,I,J) with I,J amat object with same size and I.N==a.N EXPERIMENTAL!
            assert( all(size(subs{1})==size(subs{2})) && subs{1}.N==a.N )
            [N,m,n]=size(subs{1});
            K=fc_amat.ones(N,m,n).*[1:N]';
            idx=sub2ind(size(a),K.values(:),subs{1}.values(:),subs{2}.values(:));
            a.values(idx)=b(:);
            return
          end
        
          if isamat(b)
            a.values(:,subs{1},subs{2})=b.values;
          elseif isscalar(b)
            a.values(:,subs{1},subs{2})=b;
          elseif isnumeric(b)
            if subs{1}==':', subs{1}=1:a.nr;end
            if subs{2}==':', subs{2}=1:a.nc;end
            if length(subs{1}) == size(b,1) && length(subs{2}) == size(b,2)
            
              %B=repmat(b,[a.N,1,1]);
              B=permute(repmat(b,[1,1,a.N]),[3,1,2]);
              %whos
              %B=reshape(repmat(b,[a.N,1,1]),[a.N,size(b,1),size(b,2)]);
              %whos
              a.values(:,subs{1},subs{2})=B;
            else
              a.values(:,subs{1},subs{2})=b;
              %error('Trouble with dimensions')
            end
          end
          
          a.nr=size(a.values,2);a.nc=size(a.values,3);
          return
        end
        % Implement a(K,I,J)=
        %assert(length(subs)==length(b),'s and b must have the same length');
        if isamat(subs{1}) && isamat(subs{2}) && isamat(subs{3})  
          % return a(K,I,J) with K,I,J amat object with same size and I.N==a.N EXPERIMENTAL!
          assert( all(size(subs{1})==size(subs{2})) && all(size(subs{1})==size(subs{3})) && subs{1}.N==a.N )
          idx=sub2ind(size(a),subs{1}.values(:),subs{2}.values(:),subs{3}.values(:));
          if isamat(b)
            a.values(idx)=b.values(:);
          else
            a.values(idx)=b(:);
          end
          return
        end
        if isamat(b)
          a.values(subs{:})=b.values;
        else 
          a.values(subs{:})=b;
        end
%          a.N=size(a.values,1);
%          a.nr=size(a.values,2);
%          a.nc=size(a.values,3);
     otherwise
       error('%s not implemented for amat object',s(1).type)
   end
   a.N=size(a.values,1);
   a.nr=size(a.values,2);
   a.nc=size(a.values,3);
end
